#include "clock.h"

char g_cSeconds;
char g_cMinutes;
char g_cHours;
char g_cDay;
char g_cMonth;
char g_cYear;

void InitializeClock(void)
{
	g_cSeconds = 0;
	g_cMinutes = 0;
	g_cHours = 0;
	g_cDay = 1;
	g_cMonth = 1;
	g_cYear = 6;																// 2003
}

void Increment1Second(void)
{
	int iYear;
	char g_cDays[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};	

	if(++g_cSeconds > 59) {
		g_cSeconds = 0;
		
		if(++g_cMinutes > 59) {
			g_cMinutes = 0;
			
			if(++g_cHours > 23) {
				g_cHours = 0;
				
				if(g_cMonth == 2) {												// are we in February
					iYear = 2000 + g_cYear;										// current year
					if(iYear == (iYear / 4) * 4) {								// leap year?
						g_cDays[1] = 29;										// yes, february is 29
					}
					else {
						g_cDays[1] = 28;										// no, february is 28
					}
				}

				if(++g_cDay > g_cDays[g_cMonth-1]) {
					g_cDay = 0;
	
					if(++g_cMonth > 12) {
						g_cMonth = 0;
						g_cYear++;
					}
				}
			}
		}
	}
}

char GetHour(void) {
	return g_cHours;
}

char GetMin(void) {
	return g_cMinutes;
}

char GetSec(void) {
	return g_cSeconds;
}

void GetTime(unsigned char* Hour, unsigned char* Min, unsigned char* Sec) {

	*Hour = g_cHours;
	*Min = g_cMinutes;
	*Sec = g_cSeconds;
}

